#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define N 1000

int is_paren(char *s){
    int l=strlen(s);
    int i;
    if (l==0) return 1;
    if (l%2==1) return 0;
    if (l==2 && s[0]==s[1]) return 1;
    /* try all possible closures */
    for(i=1; i<l; i++)
       if (s[0]==s[i]){
         char *sub=strndup(&s[1],i-1);
         int res=is_paren(sub);
         free(sub);
         sub=strndup(&s[i+1],l-i+2);
         res = res && is_paren(sub);
         free(sub);
         if (res) return 1;
       } 
    return 0;
}

int main(){
    char s[N];
    int i, j, l, count=0;

    /* Acquisizione input */
    scanf("%s", s);
    printf("%s\n", s);
    l=strlen(s);

    /* Calcolo su tutte le sottostringhe */
    for(i=0; i<l; i++)
        for(j=2; j<=l-i; j++){
            char *sub=strndup(&s[i],j);
            printf("Trying %s... ", sub);
            if (is_paren(sub)) {
                printf("Ok\n");
                count++;
            } else {
                printf("No\n");
            }
            free(sub);
        }
    printf("%d\n",count);

    return 0;
}
